#! /bin/sh -e
### ;;; * utf-8 *
## usage:
## 		 COMMAND -t VERSION LANGUAGE
## 	=	 COMMAND -t $2 $3
## EXAMPLE : 	#COMMAND -t 24.1 zh_CN
## -t = --translate
## updated by Careone <careone@wo.com.cn>, 20130115
## HEAD
EMACS_LOCALE_PATH='/usr/local/share/careone/emacs-locale'
EMACS_LOCALE_PATH='/usr/local/share/careone/emacs-locale'
VERSION='15.0'
#TRANSED_PATH='~/emacs-locale/usr/share/emacs/VER/site-lisp/LANG/lisp/*/*.el'
TRANSOR_SIGN_FILE='emacs-transor-sign'
FFFE='/usr/local/share/careone/emacs-locale-dev/utf-16le-bom-fffe'
#
NAME_UPPER='Emacs'
NAME_LOWER='emacs'

# SWITCHES/OPTIONAL MODULE
ENABLE_UNIX_REPLACE='1'
ENABLE_WIN_ICONV='0'
ENABLE_WIN_REPLACE='1'
SHOW_TRANSED='0'

## APP_VER=$2
## APP_LANG=$3
APP_PATH='.'
APP='menu-bar'
## example: 	APP_PATH='play'
##  	    	APP='animate'
## means: 	lisp/play/animate.el
#
## HEAD END

#
#ORG_D='org'
#PLAY_D='play'
#ERC_D='erc'
#NET_D='net'
#URL_D='url'
#GNUS_D='gnus'
#PLAY_D='play'
#ORG_D='org'
#ESHELL_D='eshell'
#TEXTMODES_D='textmodes'
#MH_E_D='mh-e'
#EMACS_LISP_D='emacs-lisp'
#LANGUAGE_D='language'
#PROGMODES_D='progmodes'
#OBSOLETE_D='obsolete'
#CALC_D='calc'
#CALENDAR_D='calendar'
#NXML_D='nxml'
#EMULATION_D='emulation'
#INTERNATIONAL_D='international'
#MAIL_D='mail'
#TERM_D='term'
###
# Usage: usage
# Print the usage.
usage () {
    cat <<EOF
Usage: $0 -t VERSION LANGUAGE
example: $0 -t 24.1 zh_CN

translate $NAME_UPPER lisp/*/*.el files to other languages.

  -t, --translate VERSION LANGUAGE
  		   translate $NAME_UPPER lisp/*/*.el files of special version
  -v, --version    print the version information and exit
  -h, --help       print this message and exit

Please report bugs to Careone <careone@wo.com.cn>.
EOF
}

# Check the arguments.
for option in "$@"; do
case    "$option" in
    -t | --translate)
### NEW Steps for translating Emacs to other languages for Unix/Windows:
# 1. copy ~/emacs-xx.x/lisp/*/*.el to ~/emacs-locale/usr/share/emacs/xx.x/
#	site-lisp/${lang_LANG}/*/*.el for next translating;
# 2. convert encoding of copied lisp/*/*.el and mark as utf-8 (important!)
# 3. translate lisp/*/*.el to LANGUAGE for Emacs/Unix;
# 4. copy translated Emacs/Unix *.el to windows directory for next steps;
# 5. if translated Unix .el not work, replace with other Unix version .el
#    translated, and keep backups named with version number;
# 6. if translated Unix .el not work in Windows, retranslate some strings of
#    top menu back to English;
# 7*. (canceled because of step 2) if Windows .el translated in step 6 
#	still not work, convert codings to Windows UNICODE 
#	(= utf-16le-with-signature in Emacs), and keep backups named with 
#	'windows` mark ;
# 8. if Windows .el translated still not work, replace it with other Windows
#    version .el translated, and keep backups named with version number;

echo "*** translate ~/${NAME_LOWER}-$2/lisp/$APP_PATH/${APP}.el and save to"
echo -n "  ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/$APP_PATH/${APP}.el ..."

## check and copy .el source files for translating, and
## if $2 (=VERSION) or $3 (=LANGAUGE) input error, or no avaid bin/ path, quit
	if ! [ -d ~/${NAME_LOWER}-$2/lisp/ ];then
		echo "~/${NAME_LOWER}-$2/lisp/ not found and nothing to do, quit."
		exit 1;
		elif ! [ -d $EMACS_LOCALE_PATH/$3/bin/ ];then
		echo "$EMACS_LOCALE_PATH/$3/bin/ not found and nothing to do, quit."
		exit 1;
	fi

## mkdir for translated .el files to save, for linux
## path: ~/emacs-locale/usr/share/emacs/VER/site-lisp/LANG/lisp/*/
if ! [ -d ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/$APP_PATH/ ];then
	mkdir -p ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/$APP_PATH/
fi

## mkdir for translated .el files to save, for windows
## path: ~/emacs-locale/windows/emacs-VER/site-lisp/LANG/lisp/*/
if ! [ -d ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/$APP_PATH/ ];then
    mkdir -p ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/$APP_PATH/
fi

## check for .el source file and save to another one for translating
if [ -e ~/${NAME_LOWER}-$2/lisp/$APP_PATH/${APP}.el ];then
	cp -p ~/${NAME_LOWER}-$2/lisp/$APP_PATH/${APP}.el ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/$APP_PATH/${APP}.el
	elif [ -e ~/${NAME_LOWER}-$2/lisp/${APP}.el ];then
	cp -p ~/${NAME_LOWER}-$2/lisp/${APP}.el ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/$APP_PATH/${APP}.el
	else echo "file not found, skip."
	exit 1;
fi

cd ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/

## iconv encoding from ? to utf-8 first, 
## or can't translate to other languages, or show in bad enconding
cat $TITLE_UTF8 $APP_PATH/${APP}.el > $APP_PATH/${APP}_utf8.el
#iconv -f ISO-8859-1 -t UTF-8 $APP_PATH/${APP}.el > $APP_PATH/${APP}_utf8.el
mv -f $APP_PATH/${APP}_utf8.el $APP_PATH/${APP}.el

## for example:
#sed -i 's/"Align"/"对齐"/g' $APP_PATH/${APP}.el

## DANGER!!! remove all lines start with "#;; L"
#sed -i '/^#;; L/d' $APP_PATH/${APP}.el

sed -i 's/"Toggle important global options"/"切换重要的全局选项"/g' $APP_PATH/${APP}.el
sed -i 's/"Sokoban"/"推箱子(sokoban)"/g' $APP_PATH/${APP}.el
sed -i 's/"Use system font"/"使用系统字体"/g' $APP_PATH/${APP}.el
sed -i 's/"Buffer boundaries"/"缓冲区包边"/g' $APP_PATH/${APP}.el
sed -i 's/"Directory name in buffer names (uniquify) %s"/"缓冲区名称中的目录名(重名) %s"/g' $APP_PATH/${APP}.el

# the "menu-bar" may be kept as original English string
#sed -i 's/"menu-bar"/"菜单栏"/g' $APP_PATH/${APP}.el

sed -i 's/"Tools"/"工具"/g' $APP_PATH/${APP}.el
sed -i 's/"Quit"/"退出"/g' $APP_PATH/${APP}.el

sed -i 's/"Hide"/"隐藏"/g' $APP_PATH/${APP}.el

sed -i 's/"Services"/"服务"/g' $APP_PATH/${APP}.el

sed -i 's/"Buffers"/"缓冲区"/g' $APP_PATH/${APP}.el
sed -i 's/"File"/"文件"/g' $APP_PATH/${APP}.el
sed -i 's/"Quit"/"退出"/g' $APP_PATH/${APP}.el

## for 22.3
sed -i 's/"Exit Emacs"/"离开 Emacs"/g' $APP_PATH/${APP}.el

sed -i 's/"Delete Frame"/"删除框架"/g' $APP_PATH/${APP}.el
sed -i 's/"New Frame on Display..."/"在其它控制台新建框架..."/g' $APP_PATH/${APP}.el
sed -i 's/"New Frame"/"新建框架"/g' $APP_PATH/${APP}.el
sed -i 's/"Remove Other Windows"/"移除其它窗格"/g' $APP_PATH/${APP}.el

sed -i 's/"New Window on Right"/"在右侧新建窗格"/g' $APP_PATH/${APP}.el
sed -i 's/"New Window Below"/"在下方新建窗格"/g' $APP_PATH/${APP}.el
sed -i 's/"Postscript Print Region"/"Postscript 打印选区"/g' $APP_PATH/${APP}.el
sed -i 's/"Postscript Print Region (B+W)"/"Postscript 打印选区(黑白)"/g' $APP_PATH/${APP}.el

sed -i 's/"Postscript Print Buffer"/"Postscript 打印缓冲区"/g' $APP_PATH/${APP}.el
sed -i 's/"Postscript Print Buffer (B+W)"/"Postscript 打印缓冲区(黑白)"/g' $APP_PATH/${APP}.el

# for 24.1
sed -i 's/"PostScript Print Region"/"PostScript 打印选区"/g' $APP_PATH/${APP}.el
sed -i 's/"PostScript Print Region (B+W)"/"PostScript 打印选区(黑白)"/g' $APP_PATH/${APP}.el

sed -i 's/"PostScript Print Buffer"/"PostScript 打印缓冲区"/g' $APP_PATH/${APP}.el
sed -i 's/"PostScript Print Buffer (B+W)"/"PostScript 打印缓冲区(黑白)"/g' $APP_PATH/${APP}.el
# 24.1 end
sed -i 's/"Remove Splits"/"移除分割"/g' $APP_PATH/${APP}.el
sed -i 's/"Split Window"/"分割窗格"/g' $APP_PATH/${APP}.el
sed -i 's/"Print Region"/"打印选区"/g' $APP_PATH/${APP}.el
sed -i 's/"Print Buffer"/"打印缓冲区"/g' $APP_PATH/${APP}.el
sed -i 's/"Recover Crashed Session"/"恢复崩溃的会话"/g' $APP_PATH/${APP}.el
sed -i 's/"Revert Buffer"/"重读缓冲区"/g' $APP_PATH/${APP}.el
sed -i 's/"Save As..."/"另存为..."/g' $APP_PATH/${APP}.el
sed -i 's/"Save"/"保存"/g' $APP_PATH/${APP}.el
sed -i 's/"Close"/"关闭"/g' $APP_PATH/${APP}.el
sed -i 's/"Insert File..."/"插入文件..."/g' $APP_PATH/${APP}.el
sed -i 's/"Open Directory..."/"打开目录..."/g' $APP_PATH/${APP}.el
sed -i 's/"Open File..."/"打开文件..."/g' $APP_PATH/${APP}.el
sed -i 's/"Visit New File..."/"访问新文件..."/g' $APP_PATH/${APP}.el
sed -i 's/"Edit the existing file FILENAME."/"编辑已有的某个文件。"/g' $APP_PATH/${APP}.el
sed -i 's/"Find file: "/"查找文件: "/g' $APP_PATH/${APP}.el
sed -i 's/"No previous search"/"无上次搜索记录"/g' $APP_PATH/${APP}.el

sed -i 's/"sSearch for string: "/"搜索字符串: "/g' $APP_PATH/${APP}.el
sed -i 's/"sSearch for regexp: "/"搜索正则表达式: "/g' $APP_PATH/${APP}.el
sed -i 's/"Incremental Search"/"渐进式搜索"/g' $APP_PATH/${APP}.el
sed -i 's/"Backward Regexp..."/"后退搜索正则表达式..."/g' $APP_PATH/${APP}.el
sed -i 's/"Forward Regexp..."/"向前搜索正则表达式..."/g' $APP_PATH/${APP}.el
sed -i 's/"Backward String..."/"后退搜索字符串..."/g' $APP_PATH/${APP}.el
sed -i 's/"Forward String..."/"向前搜索字符串..."/g' $APP_PATH/${APP}.el
sed -i 's/"Search"/"搜索"/g' $APP_PATH/${APP}.el

sed -i 's/"Continue Tags Search"/"继续搜索 Tag 标识"/g' $APP_PATH/${APP}.el
sed -i 's/"Search Tagged Files..."/"搜索带 Tag 标识的文件..."/g' $APP_PATH/${APP}.el

## for 22.3
sed -i 's/"Search tagged files..."/"搜索带 Tag 标识的文件..."/g' $APP_PATH/${APP}.el

sed -i 's/"Repeat Backwards"/"继续后退"/g' $APP_PATH/${APP}.el
sed -i 's/"Repeat Forward"/"继续向前"/g' $APP_PATH/${APP}.el

sed -i 's/"Regexp Backwards..."/"后退搜索正则表达式..."/g' $APP_PATH/${APP}.el
sed -i 's/"Regexp Forward..."/"向前搜索正则表达式..."/g' $APP_PATH/${APP}.el
sed -i 's/"String Backwards..."/"后退搜索字符串..."/g' $APP_PATH/${APP}.el
sed -i 's/"String Forward..."/"向前搜索字符串..."/g' $APP_PATH/${APP}.el
sed -i 's/"Replace"/"替换"/g' $APP_PATH/${APP}.el
sed -i 's/"Continue Replace"/"继续替换"/g' $APP_PATH/${APP}.el
sed -i 's/"Replace in Tagged Files..."/"在带 Tag 标识的文件中进行替换..."/g' $APP_PATH/${APP}.el

## for 22.3
sed -i 's/"Replace in tagged files..."/"在带 Tag 标识的文件中进行替换..."/g' $APP_PATH/${APP}.el

sed -i 's/"Replace Regexp..."/"替换正则表达式..."/g' $APP_PATH/${APP}.el
sed -i 's/"Replace String..."/"替换字符串..."/g' $APP_PATH/${APP}.el
sed -i 's/"Go To"/"转到"/g' $APP_PATH/${APP}.el

sed -i 's/"Set Tags File Name..."/"设置 Tag 标识文件名..."/g' $APP_PATH/${APP}.el
sed -i 's/"Tags Apropos..."/"相关的 Tag 标识..."/g' $APP_PATH/${APP}.el
sed -i 's/"Next Tag in Other Window"/"其它窗格的下一个 Tag 标识"/g' $APP_PATH/${APP}.el
sed -i 's/"Find Next Tag"/"查找下一个 Tag 标识"/g' $APP_PATH/${APP}.el
sed -i 's/"Find Tag in Other Window..."/"在其它窗格中查找 Tag 标识..."/g' $APP_PATH/${APP}.el
sed -i 's/"Find Tag..."/"查找 Tag 标识..."/g' $APP_PATH/${APP}.el
sed -i 's/"Goto End of Buffer"/"转到缓冲区末尾"/g' $APP_PATH/${APP}.el
sed -i 's/"Goto Beginning of Buffer"/"\转到缓冲区开头"/g' $APP_PATH/${APP}.el
sed -i 's/"Goto Buffer Position..."/"转到缓冲区位置..."/g' $APP_PATH/${APP}.el
sed -i 's/"Goto Line..."/"转到某行..."/g' $APP_PATH/${APP}.el
sed -i 's/"Select Yank"/"选择性粘贴(即召回)"/g' $APP_PATH/${APP}.el
sed -i 's/"Edit"/"编辑"/g' $APP_PATH/${APP}.el
sed -i 's/"Text Properties"/"文本属性"/g' $APP_PATH/${APP}.el
sed -i 's/"Spell"/"拼写"/g' $APP_PATH/${APP}.el
sed -i 's/"Fill"/"调整"/g' $APP_PATH/${APP}.el
sed -i 's/"Bookmarks"/"书签"/g' $APP_PATH/${APP}.el

sed -i 's/"Replace"/"替换"/g' $APP_PATH/${APP}.el
sed -i 's/"Search"/"搜索"/g' $APP_PATH/${APP}.el
sed -i 's/"Select All"/"全选"/g' $APP_PATH/${APP}.el
sed -i 's/"Clear"/"清除"/g' $APP_PATH/${APP}.el
sed -i 's/"Select and Paste"/"选择并粘贴"/g' $APP_PATH/${APP}.el
sed -i 's/"Paste from Kill Menu"/"从剪贴板(即 Kill 菜单)进行粘贴"/g' $APP_PATH/${APP}.el

## for 22.3
sed -i 's/"Paste from kill menu"/"从剪贴板(即 kill 菜单)进行粘贴"/g' $APP_PATH/${APP}.el

sed -i 's/"Paste"/"粘贴"/g' $APP_PATH/${APP}.el
sed -i 's/"Copy"/"复制"/g' $APP_PATH/${APP}.el
sed -i 's/"Cut"/"剪切"/g' $APP_PATH/${APP}.el
sed -i 's/"Undo"/"撤消"/g' $APP_PATH/${APP}.el
sed -i 's/"Customize"/"自定义"/g' $APP_PATH/${APP}.el
sed -i 's/"Faces Matching..."/"符合的外观..."/g' $APP_PATH/${APP}.el
sed -i 's/"Options Matching..."/"符合的选项..."/g' $APP_PATH/${APP}.el
sed -i 's/"All Settings Matching..."/"符合条件的全部设置..."/g' $APP_PATH/${APP}.el
sed -i 's/"Specific Group..."/"指定分组..."/g' $APP_PATH/${APP}.el
sed -i 's/"Specific Face..."/"指定外观..."/g' $APP_PATH/${APP}.el
sed -i 's/"Specific Option..."/"指定选项..."/g' $APP_PATH/${APP}.el
sed -i 's/"New Options..."/"新建选项..."/g' $APP_PATH/${APP}.el
sed -i 's/"Saved Options"/"已保存的选项"/g' $APP_PATH/${APP}.el
sed -i 's/"Browse Customization Groups"/"浏览自定义分组"/g' $APP_PATH/${APP}.el
sed -i 's/"Top-level Customization Group"/"顶级自定义分组"/g' $APP_PATH/${APP}.el
sed -i 's/"Custom Themes"/"自定义主题"/g' $APP_PATH/${APP}.el
sed -i 's/"Toggle whether to "/"是否转换到 "/g' $APP_PATH/${APP}.el
sed -i 's/"enabled globally"/"全局启用"/g' $APP_PATH/${APP}.el
sed -i 's/"disabled globally"/"全局禁用"/g' $APP_PATH/${APP}.el

sed -i 's/"Other (Customize)"/"其它(自定义) [Other (Customize)]"/g' $APP_PATH/${APP}.el
sed -i 's/"Opposite, Arrows Right"/"反方向-右箭头 (Opposite, Arrows Right)"/g' $APP_PATH/${APP}.el
sed -i 's/"Opposite, No Arrows"/"反方向-无箭头 (Opposite, No Arrows)"/g' $APP_PATH/${APP}.el
sed -i 's/"In Right Fringe"/"在右侧包边内 (In Right Fringe)"/g' $APP_PATH/${APP}.el
sed -i 's/"In Left Fringe"/"在左侧包边内 (In Left Fringe)"/g' $APP_PATH/${APP}.el
sed -i 's/"No Indicators"/"不提示 (No Indicators)"/g' $APP_PATH/${APP}.el
sed -i 's/"Fringe"/"包边"/g' $APP_PATH/${APP}.el
sed -i 's/"Buffer Boundaries"/"缓冲区边界"/g' $APP_PATH/${APP}.el
sed -i 's/"Empty Line Indicators"/"提示空行"/g' $APP_PATH/${APP}.el
sed -i 's/"Indicating of empty lines %s"/"提示空行 %s"/g' $APP_PATH/${APP}.el
sed -i 's/"Indicate trailing empty lines in fringe globally"/"在包边对末尾的空行进行提示，全局有效"/g' $APP_PATH/${APP}.el
sed -i 's/"Customize Fringe"/"自定义包边"/g' $APP_PATH/${APP}.el
sed -i 's/"Default"/"默认值 (Default)"/g' $APP_PATH/${APP}.el
sed -i 's/"On the Right"/"在右侧 (On the Right)"/g' $APP_PATH/${APP}.el
sed -i 's/"On the Left"/"在左侧 (On the Left)"/g' $APP_PATH/${APP}.el
sed -i 's/"None"/"无 (None)"/g' $APP_PATH/${APP}.el
sed -i 's/"Turn off fringe"/"关闭包边 (Turn off fringe)"/g' $APP_PATH/${APP}.el
sed -i 's/"Turn off scroll bars."/"关闭滑块。"/g' $APP_PATH/${APP}.el
sed -i 's/"Scroll-bar"/"滑块"/g' $APP_PATH/${APP}.el
sed -i 's/"Turn off scroll-bar"/"关闭滑块 (Turn off scroll-bar)"/g' $APP_PATH/${APP}.el
sed -i 's/"Do not display tool bars."/"不关闭工具栏。"/g' $APP_PATH/${APP}.el

sed -i 's/"On the Bottom"/"在底部"/g' $APP_PATH/${APP}.el
sed -i 's/"On the Top"/"在顶部"/g' $APP_PATH/${APP}.el

sed -i 's/"Show\/Hide"/"显示\/隐藏"/g' $APP_PATH/${APP}.el

sed -i 's/"Column Numbers"/"列号"/g' $APP_PATH/${APP}.el
sed -i 's/"Line Numbers"/"行号"/g' $APP_PATH/${APP}.el
sed -i 's/"Size Indication"/"显示文件大小"/g' $APP_PATH/${APP}.el
sed -i 's/"Battery Status"/"电池状态"/g' $APP_PATH/${APP}.el
sed -i 's/"Time, Load and Mail"/"时间-负载-邮件"/g' $APP_PATH/${APP}.el
sed -i 's/"Speedbar"/"快捷栏"/g' $APP_PATH/${APP}.el
sed -i 's/"Fringe"/"包边"/g' $APP_PATH/${APP}.el
sed -i 's/"Scroll-bar"/"滑块"/g' $APP_PATH/${APP}.el
sed -i 's/"Tooltips"/"工具栏提示"/g' $APP_PATH/${APP}.el
sed -i 's/"Menu-bar"/"菜单栏"/g' $APP_PATH/${APP}.el
sed -i 's/"Turn menu-bar on\/off"/"打开\/关闭菜单栏"/g' $APP_PATH/${APP}.el
sed -i 's/"Turn tool-bar on\/off"/"打开\/关闭工具栏"/g' $APP_PATH/${APP}.el
sed -i 's/"Line Wrapping"/"换行"/g' $APP_PATH/${APP}.el
sed -i 's/"Word Wrap (Visual Line mode)"/"单词换行(可见行模式) [Word Wrap (Visual Line mode)]"/g' $APP_PATH/${APP}.el

#;; for 22.3
sed -i 's/"Word Wrap in Text Modes"/"文本模式时单词换行"/g' $APP_PATH/${APP}.el

sed -i 's/"Visual-Line mode enabled"/"启用可见行模式 (Visual-Line mode enabled)"/g' $APP_PATH/${APP}.el

sed -i 's/"Truncate Long Lines"/"长行换行 (Truncate Long Lines)"/g' $APP_PATH/${APP}.el

# for 22.3
sed -i 's/"Truncate Long Lines in this Buffer"/"对当前缓冲区的长行换行"/g' $APP_PATH/${APP}.el

sed -i 's/"Wrap at Window Edge"/"在窗格边缘换行 (Wrap at Window Edge)"/g' $APP_PATH/${APP}.el

sed -i 's/"Options"/"选项"/g' $APP_PATH/${APP}.el

sed -i 's/"Customize Emacs"/"自定义 Emacs"/g' $APP_PATH/${APP}.el

sed -i 's/"Manage Emacs Packages"/"管理 Emacs 软件包"/g' $APP_PATH/${APP}.el

sed -i 's/"Save Options"/"保存选项"/g' $APP_PATH/${APP}.el

sed -i 's/"Set Default Font..."/"设置默认字体..."/g' $APP_PATH/${APP}.el

sed -i 's/"Use System Font"/"使用系统字体"/g' $APP_PATH/${APP}.el

sed -i 's/"Use system font: %s"/"使用系统字体: %s"/g' $APP_PATH/${APP}.el

sed -i 's/"Multilingual Environment"/"多国语言环境(Mule)"/g' $APP_PATH/${APP}.el

sed -i 's/"Preferences"/"参数"/g' $APP_PATH/${APP}.el

sed -i 's/"Enter Debugger on Quit\/C-g"/"退出时 (或按 C-g 键) 进入调试器"/g' $APP_PATH/${APP}.el

sed -i 's/"Debug on Quit %s"/"退出 %s 时进行调试"/g' $APP_PATH/${APP}.el

sed -i 's/"Enter Lisp debugger when C-g is pressed"/"按 C-g 键进入 Lisp 调试器"/g' $APP_PATH/${APP}.el

sed -i 's/"Enter Debugger on Error"/"出现错误时进入调试器"/g' $APP_PATH/${APP}.el

sed -i 's/"Debug on Error %s"/"出现 %s 错误时进行调试"/g' $APP_PATH/${APP}.el

sed -i 's/"Enter Lisp debugger when an error is signaled"/"出现错误信号时进入 Lisp 调试器"/g' $APP_PATH/${APP}.el

sed -i 's/"Blink Cursor"/"光标闪烁"/g' $APP_PATH/${APP}.el

sed -i 's/"Save Place in Files between Sessions"/"保存会话的文件位置"/g' $APP_PATH/${APP}.el

sed -i 's/"Saving place in files %s"/"保存文件 %s 的位置"/g' $APP_PATH/${APP}.el

sed -i 's/"Use Directory Names in Buffer Names"/"在缓冲区使用目录名"/g' $APP_PATH/${APP}.el

sed -i 's/"Use CUA Keys (Cut\/Paste with C-x\/C-c\/C-v)"/"使用 CUA 按键(使用 C-x\/C-c\/C-v 进行剪切\/粘贴)"/g' $APP_PATH/${APP}.el

sed -i 's/"Shift movement mark region (CUA)"/"按住 Shift 键并移动光标来选定区域(CUA)"/g' $APP_PATH/${APP}.el

sed -i 's/"Ignore Case for Search"/"搜索时不区分字母大小写"/g' $APP_PATH/${APP}.el

sed -i 's/"Case-Insensitive Search %s"/"区分字母大小写进行搜索 %s"/g' $APP_PATH/${APP}.el

sed -i 's/"Auto Fill in Text Modes"/"文本模式时自动调整"/g' $APP_PATH/${APP}.el

sed -i 's/"Line Wrapping in This Buffer"/"在当前缓冲区换行"/g' $APP_PATH/${APP}.el

sed -i 's/"Highlight Matching Parentheses"/"高亮配对的括号"/g' $APP_PATH/${APP}.el

sed -i 's/"Highlight Active Region"/"高亮选区"/g' $APP_PATH/${APP}.el

sed -i 's/"Gnus Message"/"Gnus 信息"/g' $APP_PATH/${APP}.el

sed -i 's/"Games"/"游戏"/g' $APP_PATH/${APP}.el

sed -i 's/"Zone Out"/"花屏(zone)"/g' $APP_PATH/${APP}.el

sed -i 's/"Tetris"/"堆积木(tetris)"/g' $APP_PATH/${APP}.el

sed -i 's/"Solitaire"/"宝石棋(solitaire)"/g' $APP_PATH/${APP}.el

sed -i 's/"Snake"/"贪食蛇(snake)"/g' $APP_PATH/${APP}.el

sed -i 's/"Pong"/"打砖块(pong)"/g' $APP_PATH/${APP}.el

sed -i 's/"Multiplication Puzzle"/"乘法谜(mpuz)"/g' $APP_PATH/${APP}.el

sed -i 's/"Life"/"生命(life)"/g' $APP_PATH/${APP}.el

sed -i 's/"Landmark"/"地标(landmark)"/g' $APP_PATH/${APP}.el

sed -i 's/"Towers of Hanoi"/"汉诺塔(hanoi)"/g' $APP_PATH/${APP}.el

sed -i 's/"Gomoku"/"五子棋(gomoku)"/g' $APP_PATH/${APP}.el

sed -i 's/"Bubbles"/"同色棋(bubbles)"/g' $APP_PATH/${APP}.el

sed -i 's/"Blackbox"/"黑箱子(blackbox)"/g' $APP_PATH/${APP}.el

sed -i 's/"Adventure"/"冒险(dunnet)"/g' $APP_PATH/${APP}.el

sed -i 's/"Encryption\/Decryption"/"加密\/解密"/g' $APP_PATH/${APP}.el

sed -i 's/"Insert Keys"/"插入密钥"/g' $APP_PATH/${APP}.el

sed -i 's/"Export Keys"/"导出密钥"/g' $APP_PATH/${APP}.el

sed -i 's/"Import Keys from Region"/"从区域导入密钥"/g' $APP_PATH/${APP}.el

sed -i 's/"Import Keys from File..."/"从文件导入密钥..."/g' $APP_PATH/${APP}.el

sed -i 's/"List Keys"/"列出密钥"/g' $APP_PATH/${APP}.el

sed -i 's/"Sign Region"/"对区域进行签名"/g' $APP_PATH/${APP}.el

sed -i 's/"Verify Region"/"验证区域"/g' $APP_PATH/${APP}.el

sed -i 's/"Encrypt Region"/"加密区域"/g' $APP_PATH/${APP}.el

sed -i 's/"Decrypt Region"/"解密区域"/g' $APP_PATH/${APP}.el

sed -i 's/"Sign File..."/"对文件进行签名..."/g' $APP_PATH/${APP}.el

sed -i 's/"Verify File..."/"验证文件..."/g' $APP_PATH/${APP}.el

sed -i 's/"Encrypt File..."/"加密文件..."/g' $APP_PATH/${APP}.el

sed -i 's/"Decrypt File..."/"解密文件..."/g' $APP_PATH/${APP}.el

sed -i 's/"Simple Calculator"/"简单计算器(calculator)"/g' $APP_PATH/${APP}.el

sed -i 's/"Programmable Calculator"/"高级计算器(calc)"/g' $APP_PATH/${APP}.el

sed -i 's/"Calendar"/"日历(calendar)"/g' $APP_PATH/${APP}.el

sed -i 's/"Directory Search"/"目录搜索"/g' $APP_PATH/${APP}.el

sed -i 's/"Send Mail (with %s)"/"发送邮件(用 %s)"/g' $APP_PATH/${APP}.el

sed -i 's/"Send a mail message"/"发送邮件信息"/g' $APP_PATH/${APP}.el

sed -i 's/"Apply Patch"/"应用补丁"/g' $APP_PATH/${APP}.el

sed -i 's/"Merge"/"合并"/g' $APP_PATH/${APP}.el

sed -i 's/"Compare (Ediff)"/"比对(Ediff)"/g' $APP_PATH/${APP}.el

sed -i 's/"Spell Checking"/"拼写检查"/g' $APP_PATH/${APP}.el

sed -i 's/"Source Code Parsers (Semantic)"/"源码解析器(语法)"/g' $APP_PATH/${APP}.el

sed -i 's/"Project support (EDE)"/"项目支持(EDE)"/g' $APP_PATH/${APP}.el

sed -i 's/"Debugger (GDB)..."/"调试器(GDB)..."/g' $APP_PATH/${APP}.el

sed -i 's/"Shell Command on Region..."/"选区内的 Shell 命令..."/g' $APP_PATH/${APP}.el

sed -i 's/"Shell Command..."/"Shell 命令..."/g' $APP_PATH/${APP}.el

sed -i 's/"Compile..."/"编译..."/g' $APP_PATH/${APP}.el

sed -i 's/"Search Files (Grep)..."/"搜索文件(Grep)..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe"/"说明"/g' $APP_PATH/${APP}.el

sed -i 's/"Show All of Mule Status"/"显示全部多国语言(Mule)状态"/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Coding System (Briefly)"/"文字编码说明(简述)"/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Coding System..."/"文字编码说明..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Input Method..."/"输入法说明..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Language Environment"/"语言环境说明"/g' $APP_PATH/${APP}.el

sed -i 's/"List Key Bindings"/"列出按键绑定"/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Display Table"/"显示表说明"/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Package..."/"软件包说明..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Face..."/"外观说明..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Variable..."/"变量说明..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Function..."/"函数说明..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Key or Mouse Operation..."/"按键和鼠标操作说明..."/g' $APP_PATH/${APP}.el

sed -i 's/"Describe Buffer Modes"/"缓冲区模式说明"/g' $APP_PATH/${APP}.el

sed -i 's/"(emacs)Glossary"/"Emacs 词汇表"/g' $APP_PATH/${APP}.el

sed -i 's/"sSubject to look up: "/"寻找 sSubject 主题"/g' $APP_PATH/${APP}.el

sed -i 's/"Search Documentation"/"搜索文档"/g' $APP_PATH/${APP}.el

sed -i 's/"Search Documentation Strings..."/"搜索文档字符串..."/g' $APP_PATH/${APP}.el

sed -i 's/"Find Any Object by Name..."/"按名称查找某个主题"/g' $APP_PATH/${APP}.el

sed -i 's/"Find Options by Value..."/"按值查找选项..."/g' $APP_PATH/${APP}.el

sed -i 's/"Find Options by Name..."/"按名称查找选项..."/g' $APP_PATH/${APP}.el

sed -i 's/"Find Commands by Name..."/"按名称查找命令..."/g' $APP_PATH/${APP}.el

sed -i 's/"Look Up Command in User Manual..."/"在用户手册中寻找命令..."/g' $APP_PATH/${APP}.el

sed -i 's/"Look Up Key in User Manual..."/"在用户手册中寻找关键词..."/g' $APP_PATH/${APP}.el

sed -i 's/"Look Up Subject in ELisp Manual..."/"在 ELisp 手册中寻找主题..."/g' $APP_PATH/${APP}.el

sed -i 's/"Look Up Subject in User Manual..."/"在用户手册中寻找主题..."/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs Terminology"/"Emacs 术语"/g' $APP_PATH/${APP}.el

sed -i 's/"More Manuals"/"更多手册"/g' $APP_PATH/${APP}.el

sed -i 's/"Read Man Page..."/"查看 Man 手册页..."/g' $APP_PATH/${APP}.el

sed -i 's/"Ordering Manuals"/"订购手册"/g' $APP_PATH/${APP}.el

sed -i 's/"Lookup Subject in all Manuals..."/"在全部手册中寻找主题..."/g' $APP_PATH/${APP}.el

## for 22.3
sed -i 's/"Lookup Subject in all manuals..."/"在全部手册中寻找主题..."/g' $APP_PATH/${APP}.el

sed -i 's/"All Other Manuals (Info)"/"其它全部 Info 手册"/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs Lisp Reference"/"Emacs Lisp 参考手册"/g' $APP_PATH/${APP}.el

sed -i 's/"Introduction to Emacs Lisp"/"Emacs Lisp 介绍"/g' $APP_PATH/${APP}.el

sed -i 's/"Help"/"帮助"/g' $APP_PATH/${APP}.el

sed -i 's/"About GNU"/"关于 GNU"/g' $APP_PATH/${APP}.el

sed -i 's/"(Non)Warranty"/"免责声明"/g' $APP_PATH/${APP}.el

sed -i 's/"Copying Conditions"/"版权条款"/g' $APP_PATH/${APP}.el

sed -i 's/"Getting New Versions"/"获取新版本"/g' $APP_PATH/${APP}.el

sed -i 's/"Finding Extra Packages"/"查找额外的软件包"/g' $APP_PATH/${APP}.el

sed -i 's/"Search Built-in Packages"/"搜索集成的软件包"/g' $APP_PATH/${APP}.el

sed -i 's/"More Manuals"/"更多手册"/g' $APP_PATH/${APP}.el

sed -i 's/"Read the Emacs Manual"/"查看 Emacs 手册"/g' $APP_PATH/${APP}.el

sed -i 's/"Search Documentation"/"搜索文档"/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs Psychotherapist"/"Emacs 心理医生(doctor)"/g' $APP_PATH/${APP}.el

sed -i 's/"Send Bug Report..."/"发送缺陷报告..."/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs Known Problems"/"Emacs 已知问题"/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs News"/"Emacs 新闻"/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs FAQ"/"Emacs 常见问题 (FAQ)"/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs Tutorial (choose language)..."/"Emacs 教程(选择语言)..."/g' $APP_PATH/${APP}.el

sed -i 's/"Emacs Tutorial"/"Emacs 教程"/g' $APP_PATH/${APP}.el

sed -i 's/"About Emacs..."/"关于 Emacs..."/g' $APP_PATH/${APP}.el

sed -i 's/"Info"/"信息"/g' $APP_PATH/${APP}.el

sed -i 's/"Never"/"从不"/g' $APP_PATH/${APP}.el

sed -i 's/"Unless uniquify is enabled"/"除非已启用重名模式"/g' $APP_PATH/${APP}.el

sed -i 's/"Always"/"总是"/g' $APP_PATH/${APP}.el

sed -i 's/"Select Frame"/"选择框架"/g' $APP_PATH/${APP}.el
## MODULE END

sed -i 's/"Frames"/"框架"/g' $APP_PATH/${APP}.el

sed -i 's/"Next Buffer"/"下一个缓冲区"/g' $APP_PATH/${APP}.el

sed -i 's/"Previous Buffer"/"上一个缓冲区"/g' $APP_PATH/${APP}.el

sed -i 's/"Select Named Buffer..."/"选择已命名的缓冲区..."/g' $APP_PATH/${APP}.el

sed -i 's/"List All Buffers"/"列出全部缓冲区"/g' $APP_PATH/${APP}.el

sed -i 's/"Minibuf"/"小缓冲"/g' $APP_PATH/${APP}.el

sed -i 's/"List Completions"/"列出补齐"/g' $APP_PATH/${APP}.el

sed -i 's/"Complete Word"/"单词补齐"/g' $APP_PATH/${APP}.el

sed -i 's/"Complete"/"补齐"/g' $APP_PATH/${APP}.el

sed -i 's/"Quit"/"退出"/g' $APP_PATH/${APP}.el

#;;; fuzzy
sed -i 's/"Enter"/"进入"/g' $APP_PATH/${APP}.el

sed -i 's/"Isearch History Forward"/"渐进式向前搜索历史"/g' $APP_PATH/${APP}.el

sed -i 's/"Isearch History Backward"/"渐进式后退搜索历史"/g' $APP_PATH/${APP}.el

sed -i 's/"Next History Item"/"下一个历史记录"/g' $APP_PATH/${APP}.el

sed -i 's/"Previous History Item"/"上一个历史记录"/g' $APP_PATH/${APP}.el

sed -i 's/"term\/x-win"/"终端\/x-win"/g' $APP_PATH/${APP}.el

sed -i 's/"term\/w32-win"/"终端\/w32-win"/g' $APP_PATH/${APP}.el

# options menu
sed -i 's/"Active Region Highlighting"/"高亮选区"/g' $APP_PATH/${APP}.el
sed -i 's/"Paren Match Highlighting"/"高亮配对的括号"/g' $APP_PATH/${APP}.el
sed -i 's/"Line Wrapping in this Buffer"/"在当前缓冲区换行"/g' $APP_PATH/${APP}.el
sed -i 's/"Blinking Cursor"/"光标闪烁"/g' $APP_PATH/${APP}.el
sed -i 's/"Case-Insensitive Search"/"区分字母大小写来搜索"/g' $APP_PATH/${APP}.el
sed -i 's/"C-x\/C-c\/C-v Cut and Paste (CUA)"/"C-x\/C-c\/C-v 剪切和粘贴(CUA)"/g' $APP_PATH/${APP}.el
sed -i 's/"External Packages"/"扩展软件包"/g' $APP_PATH/${APP}.el

# edit menu
sed -i 's/"Find Emacs Packages"/"查找 Emacs 软件包"/g' $APP_PATH/${APP}.el
sed -i 's/"Mule (Multilingual Environment)"/"Mule(多国语言环境)"/g' $APP_PATH/${APP}.el
sed -i 's/"Search Files (Grep)..."/"搜索文件(Grep)..."/g' $APP_PATH/${APP}.el
sed -i 's/"Groups Matching Regexp..."/"匹配正则表达式的分组..."/g' $APP_PATH/${APP}.el
sed -i 's/"Faces Matching Regexp..."/"匹配正则表达式的外观..."/g' $APP_PATH/${APP}.el
sed -i 's/"Options Matching Regexp..."/"匹配正则表达式的选项..."/g' $APP_PATH/${APP}.el
sed -i 's/"Settings Matching Regexp..."/"匹配正则表达式的设置..."/g' $APP_PATH/${APP}.el

sed -i 's/"(Non)Warranty"/"免责声明"/g' $APP_PATH/${APP}.el
sed -i 's/"All Other Manuals (Info)"/"其它全部手册(Info)"/g' $APP_PATH/${APP}.el
sed -i 's/"About Emacs"/"关于 Emacs"/g' $APP_PATH/${APP}.el
sed -i 's/"Read Mail (with %s)"/"查看邮件(用 %s)"/g' $APP_PATH/${APP}.el
sed -i 's/"Read Net News (Gnus)"/"查看网络新闻(Gnus)"/g' $APP_PATH/${APP}.el
sed -i 's/"Ediff Miscellanea"/"Ediff 杂项"/g' $APP_PATH/${APP}.el
sed -i 's/"Other (Customize)"/"其它(自定义)"/g' $APP_PATH/${APP}.el
# emacs 23.1 end

sed -i 's/"All"/"全部"/g' $APP_PATH/${APP}.el

sed -i 's/"Paste text from clipboard"/"从剪贴板粘贴文本"/g' $APP_PATH/${APP}.el
sed -i 's/"Copy text in region to the clipboard"/"复制选中的文字到剪贴板"/g' $APP_PATH/${APP}.el
sed -i 's/"Delete text in region and copy it to the clipboard"/"删除选区内的文字并把它复制到剪贴板"/g' $APP_PATH/${APP}.el

## for 22.3
sed -i 's/"Set Font\/Fontset..."/"设置字体\/字符集..."/g' $APP_PATH/${APP}.el
sed -i 's/"Use separate control buffer frame"/"使用分离式控制的缓冲区框架"/g' $APP_PATH/${APP}.el
sed -i 's/"Tool-bar"/"工具栏"/g' $APP_PATH/${APP}.el


### for Emacs/Windows 
### copy translated .el file to windows/ dir

	echo
	echo
	echo "* for $NAME_UPPER $2/Windows..."

cd ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/	
cp -pv $APP_PATH/${APP}.el ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/$APP_PATH/${APP}.el

### BODY END

### EXTRA WORK
## OPTIONAL MODULE
if [ $ENABLE_UNIX_REPLACE = "1" ];then
### IMPORTANT for unix
## replace 24.1 - 24.2 lisp/menu-bar.el with 23.4, or  
## menu items show in English, not in translated language.
	case "$2" in
# INIT VALUE, FOR REPLACE $2 (VERSION) FILE WITH ${MVER} (VERSION)
		24.1 | 24.2 | 24.3) UNIX_REPLACE_VER='23.4'

#unix-replace ()
	echo
	echo "* do more for $NAME_UPPER $2/Unix..."

# backup first
	echo
    	echo "* backup Unix ${NAME_UPPER} $2 and ${UNIX_REPLACE_VER} $APP_PATH/${APP}.el translated ..."

# check for translated Emacs VER_REPLACE_FROM lisp/*/*_VER_REPLACE_FROM.el (first) or lisp/*/*.el (second)
	if [ -e ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/${UNIX_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}_${UNIX_REPLACE_VER}.el ];then


        cd ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/

# copy translated xxx.el to xxx_CURRENT_VERSION.el for backup first
    	cp -pfv $APP_PATH/${APP}.el $APP_PATH/${APP}_${2}.el

# copy translated xxx.REPLACE_VERSION.el to current version directory for backup
        cp -pfv ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/${UNIX_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}_${UNIX_REPLACE_VER}.el $APP_PATH/${APP}_${UNIX_REPLACE_VER}.el

# replace
	echo
    	echo "* replace Unix $APP_PATH/${APP}.el with ${NAME_UPPER} ${UNIX_REPLACE_VER} translated ..."
        cp -pfv ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/${UNIX_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}_${UNIX_REPLACE_VER}.el $APP_PATH/${APP}.el
#	exit 0 ;
    	elif [ -e ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/${UNIX_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}.el ];then

        cd ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/

# copy translated xxx.el to xxx_CURRENT_VERSION.el for backup first
    	cp -pfv $APP_PATH/${APP}.el $APP_PATH/${APP}_${2}.el

# copy translated xxx.REPLACE_VERSION.el to current version directory for backup
        cp -pfv ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/${UNIX_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}.el $APP_PATH/${APP}_${UNIX_REPLACE_VER}.el
# replace
	echo
    	echo "* replace Unix $APP_PATH/${APP}.el with ${NAME_UPPER} ${UNIX_REPLACE_VER} translated ..."
        cp -pfv ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/${UNIX_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}.el $APP_PATH/${APP}.el
        
	else 
# copy translated xxx.el to xxx_CURRENT_VERSION.el for backup first
    	cp -pfv $APP_PATH/${APP}.el $APP_PATH/${APP}_${2}.el	

# creat an empty file for notice and future replace
	touch $APP_PATH/${APP}_${UNIX_REPLACE_VER}.el
	
	echo -n "no $APP_PATH/${APP}_${UNIX_REPLACE_VER}.el or $APP_PATH/${APP}.el"
	echo -n " in ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/${UNIX_REPLACE_VER}/site-lisp/$3/lisp/ ."
	echo " Skip."	
	fi
	;;
	esac
fi
## MODULE END
### Emacs/Unix end

### Emacs/Windows BEGAIN
	case "$2" in
	21.1 | 21.2 | 21.3 | 21.4 | 22.1 | 22.2 | 22.3) 
        echo
	echo "* do more for ${NAME_UPPER} $2/Windows..."
	cd ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/
# following double quote " (1 charactor) write as 1 or 2 charactors (\") 
# are both ok
 	sed -i 's/cons "文件"/cons "File"/g' $APP_PATH/${APP}.el
	sed -i 's/cons \"编辑\"/cons \"Edit\"/g' $APP_PATH/${APP}.el
	sed -i 's/cons \"选项\"/cons \"Options\"/g' $APP_PATH/${APP}.el
	sed -i 's/cons \"缓冲区\"/cons \"Buffers\"/g' $APP_PATH/${APP}.el
	sed -i 's/cons \"工具\"/cons \"Tools\"/g' $APP_PATH/${APP}.el
	sed -i 's/cons \"帮助\"/cons \"Help\"/g' $APP_PATH/${APP}.el
	sed -i 's/cons \"小缓冲\"/cons "Minibuf"/g' $APP_PATH/${APP}.el
## touch another empty .el file with _windows mark for remark
	touch $APP_PATH/${APP}.el $APP_PATH/${APP}_windows.el
	;;
	esac

## OPTIONAL MODULE
if [ $ENABLE_WIN_ICONV = "1" ];then
## for Emacs/Windows, some files such as
## lisp/international/mule-cmds.el
## lisp/language/chinese.el
## lisp/language/*.el
## calendar/lunar.el
##
## and more any other files which may include non-ascii charactors should
## convert translated .el file to Windows UNICODE coding
## ( = utf-16le-with-signature in Emacs) to display text well,
## and never be utf-8, gbk/gb2312/gb18030 or any other codings..
## in some Emacs versions for Windows, utf-8 may work also ok, but for
## simple and unify, we convert all to utf-16le-with-signature
		
# win_iconv () {
	echo
	echo "* do more for $NAME_UPPER $2/Windows..."

	cd ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/

	iconv -f utf-8 -t UTF-16LE $APP_PATH/${APP}.el > $APP_PATH/${APP}_utf-16le.el
	cat $FFFE $APP_PATH/${APP}_utf-16le.el > $APP_PATH/${APP}_utf-16le-bom.el
	mv -fv $APP_PATH/${APP}_utf-16le-bom.el $APP_PATH/${APP}.el
## touch an empty file for remark
	touch $APP_PATH/${APP}_utf-16le-with-signature.el
	rm -f $APP_PATH/${APP}_utf-16le.el
fi
## MODULE END

## OPTIONAL MODULE
if [ $ENABLE_WIN_REPLACE = "1" ];then
	case "$2" in

# replace translated Emacs version 24.1-24.3 file with 23.4 translated for work well	
		24.1 | 24.2 | 24.3) WIN_REPLACE_VER='23.4' 
# backup first
	echo
    	echo "* backup Windows ${NAME_UPPER} $2 and ${WIN_REPLACE_VER} $APP_PATH/${APP}.el translated ..."	 
# win-replace () {

# check for optional translated Emacs REPLACE_VERSION lisp/*/*_REPLACE_VERSION.el (first) or lisp/*/*.el (second)
	if [ -e ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-${WIN_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}_${WIN_REPLACE_VER}.el ];then

        cd ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/

# copy translated xxx.el to xxx_CURRENT_VERSION.el for backup first
    	cp -pfv $APP_PATH/${APP}.el $APP_PATH/${APP}_${2}.el

# copy translated xxx.REPLACE_VERSION.el to current version directory for backup
        cp -pfv ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-${WIN_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}_${WIN_REPLACE_VER}.el $APP_PATH/${APP}_${WIN_REPLACE_VER}.el

# replace
	echo
    	echo "* replace Windows $APP_PATH/${APP}.el with ${NAME_UPPER} ${WIN_REPLACE_VER} translated ..."
        cp -pfv ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-${WIN_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}_${WIN_REPLACE_VER}.el $APP_PATH/${APP}.el
    
    	elif [ -e ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-${WIN_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}.el ];then
        cd ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/

# copy translated xxx.el to xxx_CURRENT_VERSION.el for backup first
    	cp -pfv $APP_PATH/${APP}.el $APP_PATH/${APP}_${2}.el

# copy translated xxx.REPLACE_VERSION.el to current version directory for backup
        cp -pfv ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-${WIN_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}.el $APP_PATH/${APP}_${WIN_REPLACE_VER}.el
# replace
	echo
    	echo "* replace Windows $APP_PATH/${APP}.el with ${NAME_UPPER} ${WIN_REPLACE_VER} translated ..."
        cp -pfv ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-${WIN_REPLACE_VER}/site-lisp/$3/lisp/$APP_PATH/${APP}.el $APP_PATH/${APP}.el
        
	else 
# copy translated xxx.el to xxx_CURRENT_VERSION.el for backup first
    	cp -pfv $APP_PATH/${APP}.el $APP_PATH/${APP}_${2}.el	

# creat an empty file for notice and future replace
	touch $APP_PATH/${APP}_${WIN_REPLACE_VER}.el
	
	echo -n "no $APP_PATH/${APP}_${WIN_REPLACE_VER}.el or $APP_PATH/${APP}.el"
	echo -n " in ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-${WIN_REPLACE_VER}/site-lisp/$3/lisp/ ."
	echo " Skip."	
	fi
	;; 
	esac
fi
## MODULE END
## Emacs/Windows end
### EXTRA END

echo "Done."

## OPTIONAL MODULE
if [ $SHOW_TRANSED = "1" ];then
emacs -fw ~/${NAME_LOWER}-$2/lisp/$APP_PATH/${APP}.el ~/${NAME_LOWER}-locale/usr/share/${NAME_LOWER}/$2/site-lisp/$3/lisp/$APP_PATH/${APP}.el ~/${NAME_LOWER}-locale/windows/${NAME_LOWER}-$2/site-lisp/$3/lisp/$APP_PATH/${APP}.el &
fi
## MODULE END

	exit 0 ;;

    -h | --help)
	usage
	exit 0 ;;

    -v | --version)
	echo "$0 $VERSION"
	exit 0 ;;

    -*)
	echo "Unrecognized option \`$option'" 1>&2
	exit 1 ;;
    esac
done
exit 0;
exit 0;;

